%{
/* In der Vorlesung am 27.11.2006 gemeinsam erstellte Lsung fr einen
 * einfachen Taschenrechner mit lex.
 */
#include <stdio.h>
double akku = 0;
enum op_t { plus, minus, mal, geteilt, clear} op = clear;
%}
DIGIT   [0-9]
%option main
%%
"-"?{DIGIT}+("."{DIGIT}*)?	{
		  double tmp=atof(yytext);
		  switch (op) {
		  case plus:
		  	akku += tmp;
		  	break;
		  case minus:
		  	akku -= tmp;
		  	break;
		  case mal:
		  	akku *= tmp;
		  	break;
		  case geteilt:
		  	akku /= tmp;
		  	break;
		  case clear:
		  	akku = tmp;
		  	break;
		  }
		  printf("Ergibt %g\n", akku);
		}
"+"		op=plus;
"-"		op=minus;
"*"		op=mal;
"/"		op=geteilt;
[cC]		op=clear;
[ \t\n]		/* Leerraum ignorieren */
.		printf("Ungltiges Zeichen '%s'!\n", yytext);
<<EOF>>		return 0;
