all: pcomp
clean:
	rm -f pcomp pcomp-scan.o pcomp-parse.o pcomp-scan.c
.INTERMEDIATE: pcomp-scan.o pcomp-parse.o pcomp-scan.c

pcomp: pcomp-scan.o pcomp-parse.o
	$(CC) $(LDFLAGS) -o pcomp pcomp-scan.o pcomp-parse.o

pcomp-scan.o: pcomp-scan.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o pcomp-scan.o pcomp-scan.c

pcomp-parse.o: pcomp-parse.c pcomp.tab.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o pcomp-parse.o pcomp-parse.c

pcomp-scan.c: pcomp-scan.l pcomp.tab.h
	$(LEX) $(LFLAGS) -opcomp-scan.c pcomp-scan.l
